restart:
randomize():
N := 4; NN := N^2; T := N*(NN+1)/2;
F := sprintf("/tmp/diabolik%d.pl", N);
eq1 := seq((add(X||i||j, i=1..N)=T), j=1..N):
eq2 := seq((add(X||j||i, i=1..N)=T), j=1..N):
eq3 := seq((add(X||i||(1+((i+j) mod N)), i=1..N)=T), j=1..N):
eq4 := seq((add(X||i||(1+((j-i) mod N)), i=1..N)=T), j=1..N):
compare := proc(x,y)
nops(rhs(x)) < nops(rhs(y));
end:
sol := sort([op(solve({eq1, eq2, eq3, eq4}))], compare):
output_prolog := proc(sol)
local i, left, right, f;

f := fopen(F, WRITE);
fprintf(f, "diabolik%d(X) :-\n", N):
i := 1:
while nops(rhs(sol[i])) = 1 do i := i+1 od: 
fprintf(f, "\tX = %a", [seq(seq(X||i||j, j=1..N), i=1..N)]):
fprintf(f, ",\n\tL0 = %a", [seq(i, i=1..NN)]):

for i from 1 to NN do
  left := lhs(sol[i]):
  right := rhs(sol[i]):
  if left = right then
    fprintf(f, ",\n\tmember(%a, L%d), delete(L%d, %a, L%d)",
            left, i-1, i-1, left, i):
  else
    fprintf(f, ",\n\t%a is %a, member(%a, L%d), delete(L%d, %a, L%d)",
            left, right, left, i-1, i-1, left, i):
  fi:
od:

fprintf(f, ".\n"):
fclose(f):
end:
output_prolog_with_fd := proc(sol)
local i, left, right, f;

f := fopen(F, WRITE);
fprintf(f, "diabolik%d(X) :-\n", N):
i := 1:
while nops(rhs(sol[i])) = 1 do i := i+1 od: 
fprintf(f, "\tX = %a", [seq(seq(X||i||j, j=1..N), i=1..N)]):
fprintf(f, ",\n\tfd_all_different(X),\n\tfd_domain(X, 1, %d)", NN):

for i from 1 to NN do
  left := lhs(sol[i]):
  right := rhs(sol[i]):
  if left = right then
    fprintf(f, ",\n\tfor(Y%d, 1, %d), %a is Y%d", i, NN, left, i):
  else
    fprintf(f, ",\n\t%a is %a", left, right):
  fi:
od:

fprintf(f, ".\n"):
fclose(f):
end:
energy := proc(sol)
local i, j, total, left, right:

j := 1:
total := 0:

for i from 1 to NN do
  left := lhs(sol[i]):
  right := rhs(sol[i]):
  if left = right then
    j := j*NN;
  else
    total := total + j:
  fi:
od:

total:
end:  
optimize := proc(libres, autres)
local reste, resultat, i, j, cur, var:

reste := libres:
resultat := NULL:

for i from 1 to nops(autres) do
  cur := rhs(autres[i]):
  j := 1:
  while j <= nops(reste) do
    var := reste[j]:
    if has(cur, var) then
      reste := remove(`=`, reste, var):
      resultat := resultat, var=var:
    else
      j := j+1:
    fi:
  od:
  resultat := resultat, autres[i]:
od:

[resultat]: 
end:
split := proc(sol)
local i, libres, autres, cur:
libres := NULL:
autres := NULL:
for i from 1 to NN do
  cur := sol[i]:
  if lhs(cur) = rhs(cur) then
    libres := libres, lhs(cur):
  else
    autres := cur, autres:
  fi:
od:
[libres], [autres]:
end:
libres, autres := split(sol):
randomiser := proc(libres)
local tmp, res, i, n, j, t:
tmp := libres:
res := NULL:
n := nops(libres):
for i from 1 to n do
  j := rand(1..n+1-i)():
  t := tmp[j]:
  res := res, t:
  tmp := remove(`=`, tmp, t):
od:
[res]:
end: 
sol_opt := optimize(libres, autres):
recuit_simule := proc(libres, autres, n, a0, a)
local i, nlibres, nautres, nenergy, olibres, oautres, oenergy:

olibres := libres:
oautres := autres:
oenergy := energy(optimize(olibres, oautres)):

for i from 1 to n do
  nlibres := randomiser(olibres):
  nautres := randomiser(oautres):
  nenergy := energy(optimize(nlibres, nautres)):
  if nenergy <= oenergy then
    oenergy := nenergy:
    olibres := nlibres:
    oautres := nautres:
  else
    if RandomTools[Generate](float(method=uniform)) < exp((oenergy-nenergy)/(a0*a^n)) then
      oenergy := nenergy:
      olibres := nlibres:
      oautres := nautres:
    fi:
  fi:
od:

olibres, oautres:
end:
nlibres := libres:
nautres := autres:
nlibres, nautres := recuit_simule(nlibres, nautres, 10000, 1, 0.99); 
solution_optim := optimize(nlibres, nautres):
energy(solution_optim);
output_prolog(optimize(nlibres, nautres));

